typedef unsigned long long int64;

/*The code is here, omitting some detail, like size of an integer.*/
void power(int64* r, const int64* b, const int64* e, int64* p)
{
	static int thresholds[] = { 0,6,24,80,240,672,1792,4608 };
	int i, j, k, l, m, win_size;
	char* bits = (char*)malloc(BITS * e_size);
	int64 t;
	int64* b_square;

	/*Get the bits of e*/
	for (i = 0, k = 0; i < e_size - 1; i++)
		for (j = 0, t = e[i]; j < BITS; j++)
			bits[k++] = t >> j & 1;
	for (j = 0, t = e[i]; j < BITS; j++)
		if (bits[k++] = t >> j & 1)
			i = j;
	i += BITS * (e_size - 1) - 1;
	for (win_size = 1; thresholds[win_size] < i; win_size++);

	/*Get b^1 / R mod p, b^3 / R mod p, ...*/
	b_power = allocate_array(1 << win_size - 1);	//Allcoate memory for an array.
	b_square = (int64*)malloc(8 * p_size);
	b_power = (int64*)malloc(8 * p_size);
	redc2(b_power, b, r_square);	//redc2(r, x, y) sets r = x * y / R mod p.
	redc2(b_square, b_power, b_power);
	for (j = 1; j < 1 << win_size - 1; j++)
	{
		(b_power + j) = (int64*)malloc(8 * p_size);
		redc2(b_power + j, b_power + j - 1, b_square);
	}

	/*Sliding window algorithm.*/
	for (copy(r, b_power); i >= 0; i--)
		if (bits[i])
		{
			l = i - win_size >= -1 ? win_size - 1 : i;
			for (j = l; !bits[i - j]; j--);
			for (k = 0, m = 0; k < j; redc2(r, r, r))
				m += bits[i - k] << j - (++k);
			redc2(r, r, r);	//Square.
			for (redc2(r, r, b_power + m); k < l; k++)
				redc2(r, r, r);	//Multiplication.
			i -= win_size - 1;
		}
		else
			redc2(r, r, r);
	redc1(r, r);	//redc1(r, x) sets r = x / R mod p.
}
